<?php
/*
Plugin Name: Question and Answer Forum
Description: Allows users to ask questions which can be answered by the author or other visitors to the site
Author: David Woodford
Version:1.2.2
Author URI: hhttp://trevorpythag.co.uk
*/

//add_filter("wp_footer","requestbox");
add_action('activate_question/.question.php', 'qinstall');
//add_action('admin_menu', 'bot_admin_actions');
add_action('wp_head','q_header_code');								//adds required scripts to header
//add_action("widgets_init", array('userwidgit', 'register'));		//adds the user login widget
//====================================================question and answers
add_action( 'init', 'create_question_post_type' );
//add_action( 'wp_print_scripts', 'q_scripts' ); 
add_action('admin_menu', 'qoptions_menu');
register_activation_hook( __FILE__, 'q_activate' );
add_action('wp_print_scripts','enqueue_question_scripts');
add_action('wp_print_styles','enqueue_question_styles');
//add_filter('wp_notify_postauthor','answer_notification_email');
if(!function_exists("wp_notify_postauthor"))
{
	include "answeremail.php";
}
//include "postcomments.php";
global $questionformid;
$questionformid = 0;

function q_activate()
{
	update_option('q_loginrequired_ask','TRUE');
	update_option('q_logintorate','TURE');
	update_option('q_answerratings','FALSE');
}

function create_question_post_type() {
	register_post_type( 'question',
		array(
			'labels' => array(
				'name' => __( 'Questions' ),
				'singular_name' => __( 'Question' ),
				'add_new_item' => __('Ask new question'),
				'edit_item' => __('change question'),
				'view_item' => __('view question')
			),
			'public' => true,
			'supports' => array('title','editor','comments','custom-fields'),
			'taxonomies' => array( 'post_tag','category')
		)
	);
}

function q_header_code()
{
	echo "<script type='text/javascript'>var blogurl;blogurl = '" . get_bloginfo('wpurl'). "';</script>";
}


function enqueue_question_scripts()
{
	wp_enqueue_script('question_ajax', '/wp-content/plugins/question-and-answer-forum/ajax.js');
}
function enqueue_question_styles()
{
	wp_enqueue_style('question_style','/wp-content/plugins/question-and-answer-forum/style.css',null,'1.0','all');
}
//allow short codes  [question_form]
function question_form($atts,$content = "")
{
	global $questionformid;
	include "askquestionform.php";
	return $html;
}
add_shortcode('question_form','question_form');

//[qarchive_link] params accepted are author=<user name> or "" for current user and category=<category> 
//first filters by specified user then by category then current user then all questions
function qarchive_link($atts,$content)
{
	global $current_user;
	$url = get_bloginfo('wpurl');
	get_currentuserinfo();
	if(isset($atts['author']))
	{
		if(($atts['author'] == "%" )&& (isset($current_user->user_login))){
			$url = $url . "/author/" . $current_user->user_login . "/?post_type=question";
		}
		else{
			$url = $url . "/author/" . $atts['author'] . "/?post_type=question";
		}		
	}
	elseif(isset($atts['category']))
	{
		$url = $url . "/category/" . $atts['category'] . "/?post_type=question";
	}
	else{
		$url = $url . "/?post_type=question";
	}		
	return "<a href='$url'>$content</a>";

}
add_shortcode('qarchive_link','qarchive_link');

include_once "querys.php";
add_shortcode('list_questions','q_list_questions');

//=============================================================================Cat links
add_filter('category_link','question_cat_link');
function question_cat_link($caturl)
{
	global $post;
	if((get_option('q_cat_links')=="TRUE") && ((get_post_type() == 'question') || (get_post_meta($post->ID,'section',true)=='questions')) )
	{
		if(strpos($caturl,'?')==false)
		{
			$caturl = "$caturl?post_type=question";
		}
		else
		{
			$caturl = "$caturl&post_type=question";
		}
	}
	return $caturl;
}

//=================================================================================BLOG info
function bloginfo_shortcode( $atts ) {
    extract(shortcode_atts(array(
        'key' => '',
    ), $atts));
    return get_bloginfo($key);
}
add_shortcode('bloginfo', 'bloginfo_shortcode');


function qoptions_menu() {

    add_options_page("Question Options1", "Q&A Forum","manage_options", "qoptions_page" , "qoptions_page");

}
function qoptions_page()
{
	include "options-page.php";
}

function q_loginform($redirecturl)
{
	$html = "";
	$html = "<form method='post' action='" . get_bloginfo('wpurl') . "/wp-login.php' name='loginform'>";
	$html .= "<p><label>Username</label><br /><input type='text' name='log' class='input' /></p>";
	$html .="<p><label>Password</label><br /><input type='password' name='pwd' class='input' /></p>";
	$html .= "<input type='hidden' name='redirect_to' value='$redirecturl' />";
	$html .= "<input type='hidden' name='testcookie' value='1' />";
	$html .= "<p><input type='submit' name='wp-submit' value='login'</p>";
	$html .= "<a href='" . get_bloginfo('wpurl') . "/wp-signup.php?callback=?&amp;template=default'>Register</a>";
	return $html;
}

//=============================================================================dashboard widget
add_action('wp_dashboard_setup','add_question_db_widget');
function add_question_db_widget()
{
	wp_add_dashboard_widget('question_widget','Recent Questions','q_db_widget');
}
function q_db_widget()
{
	$atts['questions'] = 5;
	echo q_list_questions($atts,"");
}
function q_admin_head() {
	$siteurl = get_bloginfo('wpurl');
	$url = $siteurl . '/wp-content/plugins/question-and-answer-forum/adminstyle.css';
	echo "<link rel='stylesheet' type='text/css' href='$url' />\n";
}
add_action('admin_head', 'q_admin_head');


/*
//=================================================================================rate answers
// the script rateanswer.php handles a request to rate an answer use the comment meta table

add_filter('comment_text','q_show_rate_link',99);
function q_show_rate_link($content)
{
	$comment_id = get_comment_ID();
	$currentmeta =get_comment_meta($comment_id,'qans_ratingmeta');
	$meta = explode(":",$currentmeta[0]);
	$rating = $meta[0];
	$number = $meta[1];
	if($rating > 0)
	{
		$ratinghtml = "<span id='comment_rating_" . $comment_id . "'>Average Rating:" . substr($rating,0,3) . "/5 &nbsp; Rate:";
	}
	else{
		$ratinghtml = "<span id='comment_rating_" . $comment_id . "'>No ratings yet &nbsp; Rate:";
	}
	
	for($i=1;$i<6;$i++)
	{
		$ratinghtml = $ratinghtml . "<span class='comment_rate_link_" . $i . "' onclick='rateanswer(" . $comment_id . "," . $i . ",\"comment_rating_" . $comment_id . "\");'>" . $i . "</span>";
	}
	$ratinghtml = $ratinghtml . "</span>";
	$content = $ratinghtml . $content;
	return $content;
	
}
*/
?>
